//
//  settings.c
//  dstat-firmware
//
//  Created by Michael Dryden on 2015-10-14.
//  Copyright © 2015 wheeler lab. All rights reserved.
//
//  Save/Retrieve settings from EEPROM

#include "settings.h"

// From module: NVM - Non Volatile Memory
#include <nvm.h>

// From module: NVM - Non volatile memory access
#include <common_nvm.h>

#define SETTINGS_EEPROM_PARAM_PAGE 1
#define SETTINGS_EEPROM_OFFSET_ADDR SETTINGS_EEPROM_PARAM_PAGE * EEPROM_PAGE_SIZE

void settings_read_eeprom(void){
    nvm_eeprom_read_buffer(SETTINGS_EEPROM_OFFSET_ADDR, &settings, EEPROM_PAGE_SIZE);
    printf("#INFO: SETTINGS\n\r");
    printf("#INFO: max5443_offset = %u\n\r", settings.max5443_offset);
    printf("#INFO: tls_enabled = %u\n\r", settings.tls_enabled);
    printf("#INFO: tls_clear_threshold = %u\n\r", settings.tls_clear_threshold);
}

void settings_write_eeprom(void){
    nvm_eeprom_load_page_to_buffer(&settings);
    nvm_eeprom_atomic_write_page(SETTINGS_EEPROM_OFFSET_ADDR);
}